import { RaamCSS, RaamStyleProps, RaamTheme } from "./types";
interface WithRaamTheme {
    theme?: RaamTheme;
}
interface WithIndex {
    index?: number;
}
interface RaamStylePropsPrivate extends RaamStyleProps {
    flexGap?: RaamStyleProps["gap"];
}
interface StylePropsToCSS extends RaamStylePropsPrivate, WithRaamTheme {
}
export declare const stylePropsToCSS: ({ theme, ...props }: StylePropsToCSS) => RaamCSS;
declare type FlexVariants = "hStack" | "vStack" | "wrap";
declare type FlexParentStyleProps = "alignItems" | "alignContent" | "flexDirection" | "flexWrap" | "gap" | "justifyContent" | "justifyItems";
interface FlexParentProps extends WithRaamTheme, Pick<RaamStyleProps, FlexParentStyleProps> {
    withoutBaseStyles?: boolean;
    withoutElementStyles?: boolean;
}
declare type FlexChildStyleProps = "flex" | "flexGrow" | "flexBasis" | "flexShrink";
interface FlexChildProps extends WithIndex, FlexParentProps, Pick<RaamStyleProps, FlexChildStyleProps> {
}
export interface UseFlexProps extends FlexParentProps, WithRaamTheme {
    variant?: FlexVariants;
}
export interface UseFlexChildProps extends Pick<FlexChildProps, "index" | FlexChildStyleProps> {
}
export declare type UseFlexStylePropsKeys = FlexChildStyleProps | FlexParentStyleProps;
export interface UseFlexStyleProps extends Pick<RaamStyleProps, UseFlexStylePropsKeys> {
}
export declare const useFlex: (props?: UseFlexProps) => {
    parent: () => RaamCSS;
    child: (childProps?: UseFlexChildProps) => RaamCSS;
};
export {};
